unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IniFiles, ComCtrls, MMSYSTEM;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    GroupBox3: TGroupBox;
    CheckBox5: TCheckBox;
    Label3: TLabel;
    ComboBox2: TComboBox;
    CheckBox6: TCheckBox;
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
  private
    { Private 錾 }
    procedure SetKeyData;
  public
    { Public 錾 }
  end;

type
  KeyData = record
    Code: Integer;
    Name: String;
  end;

var
  Form1: TForm1;
  StopKey, ZeroKey: Integer;
  KeyList: Array[1..107] of KeyData;

  // TEhp
  prev_w, prev_space, prev_break, prev_zero: Boolean;
  snd_w, snd_space, snd_break, snd_zero: TMemoryStream;

  // }EXp
  prev_L, prev_M: Boolean;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  ini: TIniFile;
  i: Integer;
begin
  // L[f[^ǂݍ
  SetKeyData;

  // ݒt@Cǂݍ
  ini:= TIniFile.Create( ExtractFilePath(ParamStr(0)) + 'Setting.ini' );
  try
    // XgbvL
    CheckBox1.Checked:= ini.ReadBool('Setting', 'Enable_Stop', True);
    // ZeroL
    CheckBox5.Checked:= ini.ReadBool('Setting', 'Enable_Zero', True);

    // XgbvɎgL[擾iftHgSHIFTL[j
    StopKey:= ini.ReadInteger('Setting', 'StopKey', 5);
    // 0,0ɎgL[擾iftHgCTRLL[j
    ZeroKey:= ini.ReadInteger('Setting', 'ZeroKey', 6);
    // \W擾iftHg0,0j
    Self.Left:= ini.ReadInteger('Setting', 'WindowLeft', 0);
    Self.Top:= ini.ReadInteger('Setting', 'WindowTop', 0);
    // J[\ړǂݍ
    TrackBar1.Position:= ini.ReadInteger('Setting', 'MoveDistance', TrackBar1.Position);
    Edit1.Text:= IntToStr(TrackBar1.Position);
    if TrackBar1.Position=0 then Edit1.Text:= '';

    // TEhݒǂݍ
    CheckBox2.Checked:= ini.ReadBool('Setting', 'Sound_w', True);
    CheckBox3.Checked:= ini.ReadBool('Setting', 'Sound_space', True);
    CheckBox4.Checked:= ini.ReadBool('Setting', 'Sound_break', True);
    CheckBox6.Checked:= ini.ReadBool('Setting', 'Sound_zero', True);
  finally
    ini.Free;
  end;

  // R{{bNXɃL[\
  for i:=1 to 107 do
  begin
    ComboBox1.Items.Add(KeyList[i].Name);
  end;
  ComboBox1.ItemIndex:= StopKey - 1;

  for i:=1 to 107 do
  begin
    ComboBox2.Items.Add(KeyList[i].Name);
  end;
  ComboBox2.ItemIndex:= ZeroKey - 1;

  // gbNo[̌ڕύX
  SetWindowLong(TrackBar1.Handle, GWL_STYLE, $44010041);
  SetWindowPos(TrackBar1.Handle,0,0,0,0,0,
               SWP_NOMOVE or SWP_NOSIZE or
               SWP_NOZORDER or SWP_FRAMECHANGED);

  // TEhp
  prev_w:= False;
  prev_space:= False;

  snd_w:= TMemoryStream.Create;
  snd_w.LoadFromFile('snd_w.wav');

  snd_space:= TMemoryStream.Create;
  snd_space.LoadFromFile('snd_space.wav');

  snd_break:= TMemoryStream.Create;
  snd_break.LoadFromFile('snd_break.wav');

  snd_zero:= TMemoryStream.Create;
  snd_zero.LoadFromFile('snd_zero.wav');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  ini: TIniFile;
begin
  // ݒt@Cǂݍ
  ini:= TIniFile.Create( ExtractFilePath(ParamStr(0)) + 'Setting.ini' );
  try
    // Xgbv Zero L 
    ini.WriteBool('Setting', 'Enable_Stop', CheckBox1.Checked);
    ini.WriteBool('Setting', 'Enable_Zero', CheckBox5.Checked);

    // XgbvɎgL[
    ini.WriteInteger('Setting', 'StopKey', StopKey);
    // ZeroɎgL[
    ini.WriteInteger('Setting', 'ZeroKey', ZeroKey);
    // \W
    ini.WriteInteger('Setting', 'WindowLeft', Self.Left);
    ini.WriteInteger('Setting', 'WindowTop', Self.Top);
    // J[\ړ
    ini.WriteInteger('Setting', 'MoveDistance', TrackBar1.Position);

    // TEhݒ菑
    ini.WriteBool('Setting', 'Sound_w', CheckBox2.Checked);
    ini.WriteBool('Setting', 'Sound_space', CheckBox3.Checked);
    ini.WriteBool('Setting', 'Sound_break', CheckBox4.Checked);
    ini.WriteBool('Setting', 'Sound_zero', CheckBox6.Checked);
  finally
    ini.Free;
  end;

  snd_w.Free;
  snd_space.Free;
  snd_break.Free;
  snd_zero.Free;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  // L؂ւ
  //Timer1.Enabled:= CheckBox1.Checked;

  // ^C}[Ɏ[
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  CursorPos: TPoint;
  CursorPosWindow: HWND;
  WindowRect: TRect;
  x, y, w, h, cx, cy, sx, sy: Integer;
  now_w, now_space, now_break, now_zero: Boolean;
begin
  {
  // }EXNbNW
  now_L:= False;
  if GetKeyState(VK_LBUTTON)<0 then now_L:= True;
  if (not prev_L) and now_L then
  begin
    keybd_event(Ord('W'), 0, 0, 0);
    keybd_event(Ord('W'), 0, windows.KEYEVENTF_KEYUP, 0);
//    PlaySound(snd_w.Memory, 0, SND_MEMORY or SND_ASYNC);
  end;
  prev_L:= now_L;

  // }EXzC[NbNŃXy[X
  now_M:= False;
  if GetKeyState(VK_MBUTTON)<0 then now_M:= True;
  if (not prev_M) and now_M then
  begin
    keybd_event(VK_SPACE, 0, 0, 0);
    keybd_event(VK_SPACE, 0, windows.KEYEVENTF_KEYUP, 0);
//    PlaySound(snd_w.Memory, 0, SND_MEMORY or SND_ASYNC);
  end;
  prev_M:= now_M;
  }


  if CheckBox2.Checked then
  begin
    // TEh w
    now_w:= False;
    if GetKeyState(Ord('W'))<0 then now_w:= True;
    if (not prev_w) and now_w then
    begin
      PlaySound(snd_w.Memory, 0, SND_MEMORY or SND_ASYNC);
    end;
    prev_w:= now_w;
  end;

  if CheckBox3.Checked then
  begin
    // TEh space
    now_space:= False;
    if GetKeyState(Ord(' '))<0 then now_space:= True;
    if (not prev_space) and now_space then
    begin
      PlaySound(snd_space.Memory, 0, SND_MEMORY or SND_ASYNC);
    end;
    prev_space:= now_space;
  end;

  if CheckBox4.Checked then
  begin
    // TEh break
    now_break:= False;
    if GetKeyState(KeyList[StopKey].Code)<0 then now_break:= True;
    if (not prev_break) and now_break then
    begin
      if CheckBox1.Checked then PlaySound(snd_break.Memory, 0, SND_MEMORY or SND_ASYNC);
    end;
    prev_break:= now_break;
  end;

  // zero
  if CheckBox5.Checked then
  begin
    now_zero:= False;
    if GetKeyState(KeyList[ZeroKey].Code)<0 then now_zero:= True;
    if (not prev_zero) and now_zero then
    begin
      SetCursorPos(0, 0);
      if CheckBox6.Checked then PlaySound(snd_zero.Memory, 0, SND_MEMORY or SND_ASYNC);
    end;
    prev_zero:= now_zero;
  end;

  // ړȂI
  if not CheckBox1.Checked then Exit;

  // XgbvpL[ĂȂI
  if GetKeyState(KeyList[StopKey].Code)>=0 then Exit;

  // J[\ʒu擾
  GetCursorPos(CursorPos);

  // J[\ʒũEChEnh擾
  CursorPosWindow:= WindowFromPoint(CursorPos);

  // J[\ʒũEChẼTCY擾
  GetWindowRect(CursorPosWindow, WindowRect);

  // ʒuvZ
  x:= WindowRect.Left;
  y:= WindowRect.Top;
  w:= WindowRect.Right - x;
  h:= WindowRect.Bottom - y;

  x:= x + (w div 2);
  y:= y + (h div 2);

  // J[\ړiCɁj
  if TrackBar1.Position=0 then
  begin
    SetCursorPos(x, y);
    Exit;
  end;

  // J[\ړiXɁj
  cx:= CursorPos.X;
  cy:= CursorPos.Y;

  sx:= cx;
  sy:= cy;

  // ʒuƃJ[\ʒuCursorMoveDistancesNZȓȂCɒ
  if Abs(x-cx)<TrackBar1.Position then sx:= x;
  if Abs(y-cy)<TrackBar1.Position then sy:= y;

  if sx<>x then
  begin
    if cx<x then sx:= cx + TrackBar1.Position;
    if cx>x then sx:= cx - TrackBar1.Position;
  end;

  if sy<>y then
  begin
    if cy<y then sy:= cy + TrackBar1.Position;
    if cy>y then sy:= cy - TrackBar1.Position;
  end;

  SetCursorPos(sx, sy);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  // ړύX
  Edit1.Text:= IntToStr(TrackBar1.Position);
  // 0 Ȃ瑦ړ
  if TrackBar1.Position=0 then Edit1.Text:= '';
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  // XgbvpL[ύX
  StopKey:= ComboBox1.ItemIndex + 1;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  // ZeropL[ύX
  ZeroKey:= ComboBox2.ItemIndex + 1;
end;

procedure TForm1.SetKeyData;
begin
  // L[f[^ݒ
  KeyList[1].Code:=8; KeyList[1].Name:='BackSpace';
  KeyList[2].Code:=9; KeyList[2].Name:='Tab';
  KeyList[3].Code:=12; KeyList[3].Name:='Clear';
  KeyList[4].Code:=13; KeyList[4].Name:='Enter';
  KeyList[5].Code:=16; KeyList[5].Name:='Shift';
  KeyList[6].Code:=17; KeyList[6].Name:='Ctrl';
  KeyList[7].Code:=18; KeyList[7].Name:='Alt';
  KeyList[8].Code:=19; KeyList[8].Name:='Pause';
  KeyList[9].Code:=20; KeyList[9].Name:='Shift+CapsLock';
  KeyList[10].Code:=27; KeyList[10].Name:='Esc';
  KeyList[11].Code:=29; KeyList[11].Name:='ϊ';
  KeyList[12].Code:=32; KeyList[12].Name:='Space';
  KeyList[13].Code:=33; KeyList[13].Name:='PageUp';
  KeyList[14].Code:=34; KeyList[14].Name:='PageDown';
  KeyList[15].Code:=35; KeyList[15].Name:='End';
  KeyList[16].Code:=36; KeyList[16].Name:='Home';
  KeyList[17].Code:=37; KeyList[17].Name:='';
  KeyList[18].Code:=38; KeyList[18].Name:='';
  KeyList[19].Code:=39; KeyList[19].Name:='';
  KeyList[20].Code:=40; KeyList[20].Name:='';
  KeyList[21].Code:=44; KeyList[21].Name:='PrintScreen';
  KeyList[22].Code:=45; KeyList[22].Name:='Insert';
  KeyList[23].Code:=46; KeyList[23].Name:='Delete';
  KeyList[24].Code:=48; KeyList[24].Name:='0';
  KeyList[25].Code:=49; KeyList[25].Name:='1';
  KeyList[26].Code:=50; KeyList[26].Name:='2';
  KeyList[27].Code:=51; KeyList[27].Name:='3';
  KeyList[28].Code:=52; KeyList[28].Name:='4';
  KeyList[29].Code:=53; KeyList[29].Name:='5';
  KeyList[30].Code:=54; KeyList[30].Name:='6';
  KeyList[31].Code:=55; KeyList[31].Name:='7';
  KeyList[32].Code:=56; KeyList[32].Name:='8';
  KeyList[33].Code:=57; KeyList[33].Name:='9';
  KeyList[34].Code:=65; KeyList[34].Name:='A';
  KeyList[35].Code:=66; KeyList[35].Name:='B';
  KeyList[36].Code:=67; KeyList[36].Name:='C';
  KeyList[37].Code:=68; KeyList[37].Name:='D';
  KeyList[38].Code:=69; KeyList[38].Name:='E';
  KeyList[39].Code:=70; KeyList[39].Name:='F';
  KeyList[40].Code:=71; KeyList[40].Name:='G';
  KeyList[41].Code:=72; KeyList[41].Name:='H';
  KeyList[42].Code:=73; KeyList[42].Name:='I';
  KeyList[43].Code:=74; KeyList[43].Name:='J';
  KeyList[44].Code:=75; KeyList[44].Name:='K';
  KeyList[45].Code:=76; KeyList[45].Name:='L';
  KeyList[46].Code:=77; KeyList[46].Name:='M';
  KeyList[47].Code:=78; KeyList[47].Name:='N';
  KeyList[48].Code:=79; KeyList[48].Name:='O';
  KeyList[49].Code:=80; KeyList[49].Name:='P';
  KeyList[50].Code:=81; KeyList[50].Name:='Q';
  KeyList[51].Code:=82; KeyList[51].Name:='R';
  KeyList[52].Code:=83; KeyList[52].Name:='S';
  KeyList[53].Code:=84; KeyList[53].Name:='T';
  KeyList[54].Code:=85; KeyList[54].Name:='U';
  KeyList[55].Code:=86; KeyList[55].Name:='V';
  KeyList[56].Code:=87; KeyList[56].Name:='W';
  KeyList[57].Code:=88; KeyList[57].Name:='X';
  KeyList[58].Code:=89; KeyList[58].Name:='Y';
  KeyList[59].Code:=90; KeyList[59].Name:='Z';
  KeyList[60].Code:=91; KeyList[60].Name:='Windows';
  KeyList[61].Code:=92; KeyList[61].Name:='EWindows';
  KeyList[62].Code:=93; KeyList[62].Name:='ApplicationMenu';
  KeyList[63].Code:=96; KeyList[63].Name:='0';
  KeyList[64].Code:=97; KeyList[64].Name:='1';
  KeyList[65].Code:=98; KeyList[65].Name:='2';
  KeyList[66].Code:=99; KeyList[66].Name:='3';
  KeyList[67].Code:=100; KeyList[67].Name:='4';
  KeyList[68].Code:=101; KeyList[68].Name:='5';
  KeyList[69].Code:=102; KeyList[69].Name:='6';
  KeyList[70].Code:=103; KeyList[70].Name:='7';
  KeyList[71].Code:=104; KeyList[71].Name:='8';
  KeyList[72].Code:=105; KeyList[72].Name:='9';
  KeyList[73].Code:=106; KeyList[73].Name:='*';
  KeyList[74].Code:=107; KeyList[74].Name:='+';
  KeyList[75].Code:=109; KeyList[75].Name:='-';
  KeyList[76].Code:=110; KeyList[76].Name:='.';
  KeyList[77].Code:=111; KeyList[77].Name:='/';
  KeyList[78].Code:=112; KeyList[78].Name:='F1';
  KeyList[79].Code:=113; KeyList[79].Name:='F2';
  KeyList[80].Code:=114; KeyList[80].Name:='F3';
  KeyList[81].Code:=115; KeyList[81].Name:='F4';
  KeyList[82].Code:=116; KeyList[82].Name:='F5';
  KeyList[83].Code:=117; KeyList[83].Name:='F6';
  KeyList[84].Code:=118; KeyList[84].Name:='F7';
  KeyList[85].Code:=119; KeyList[85].Name:='F8';
  KeyList[86].Code:=120; KeyList[86].Name:='F9';
  KeyList[87].Code:=121; KeyList[87].Name:='F10';
  KeyList[88].Code:=122; KeyList[88].Name:='F11';
  KeyList[89].Code:=123; KeyList[89].Name:='F12';
  KeyList[90].Code:=144; KeyList[90].Name:='NumLock';
  KeyList[91].Code:=145; KeyList[91].Name:='ScrollLock';
  KeyList[92].Code:=186; KeyList[92].Name:=':';
  KeyList[93].Code:=187; KeyList[93].Name:=';';
  KeyList[94].Code:=188; KeyList[94].Name:=',';
  KeyList[95].Code:=189; KeyList[95].Name:='-';
  KeyList[96].Code:=190; KeyList[96].Name:='.';
  KeyList[97].Code:=191; KeyList[97].Name:='/';
  KeyList[98].Code:=192; KeyList[98].Name:='@';
  KeyList[99].Code:=219; KeyList[99].Name:='[';
  KeyList[100].Code:=220; KeyList[100].Name:='\';
  KeyList[101].Code:=221; KeyList[101].Name:=']';
  KeyList[102].Code:=222; KeyList[102].Name:='^';
  KeyList[103].Code:=226; KeyList[103].Name:='\';
  KeyList[104].Code:=229; KeyList[104].Name:='p/Sp';
  KeyList[105].Code:=229; KeyList[105].Name:='O';
  KeyList[106].Code:=240; KeyList[106].Name:='CapsLock';
  KeyList[107].Code:=242; KeyList[107].Name:='J^JiЂ炪';
end;

end.
